import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class represents a field of grass populated by a flock of sheep. 
 * You do not need to change this.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Field extends World
{

    // Width of the sheep-field in cell-uints.
    public static final int FLD_WID = 50;

    // Height of the sheep-field in cell-uints.
    public static final int FLD_HGH = 38;


 
    /**
     * Constructor.
     */
    public Field()
    {    
        // Create a new world with given width and height in cell-units. Set size of a cell size to 16x16 pixels.
        super(FLD_WID, FLD_HGH, 24); 

        // Add bricks to top 3 rows in the field.
        for (int i=0;i < 3 ;++i) {
            for (int j= 0; j < FLD_WID; ++j) {
                Brick bTemp = new Brick();
                addObject(bTemp, j,i);
            }
        }

        // Add bricks to the leftmost and rightmost columns of the field.
        for (int j=1; j < FLD_HGH; ++j) {
            Brick bTemp = new Brick();
            addObject(bTemp, 0, j);

            bTemp = new Brick();
            addObject(bTemp, FLD_WID-1,j);

        }
        
        // Add bricks to last row in the field.
        for (int j= 0; j < FLD_WID; ++j) {
            Brick bTemp = new Brick();
            addObject(bTemp, j,FLD_HGH-1);
        }
        
        // Make counter
        Counter counter = new Counter();
        addObject(counter, 10 ,1);
        //Perepare field as intialized using the visual interface for Greenfoot.
        prepare();
    }

     /**
     * This function checks if a given location in the field is empty or occupied.
     * Input :
     *  x - x-index in cell units for given location.
     *  y - y-index in cell units for given location.
     *  
     *  Output : A boolean flag indicating if given location is empty or occupied.
     *  true  - empty
     *  false - occupied
     */
    public boolean isEmpty(int x, int y)
    {
        java.util.List lTemp = getObjectsAt(x, y, null);

        return lTemp.isEmpty();
    }
    
    /**
     * This function checks if a given location has a brick  or not.
     * Input :
     *  x - x-index in cell units for given location.
     *  y - y-index in cell units for given location.
     *  
     *  Output : A boolean flag indicating if the presence/absence of a brick.
     *  true  - a brick present at given location.
     *  false - no brick present at given location.
     */
    public boolean hasBrickAt(int x, int y)
    {
        java.util.List lTemp = getObjectsAt(x, y, Brick.class);

        return !lTemp.isEmpty();
    }
    
    /**
     * This function checks if a given location has a sheep or not.
     * Input :
     *  x - x-index in cell units for given location.
     *  y - y-index in cell units for given location.
     *  
     *  Output : A boolean flag indicating if the presence/absence of a sheep.
     *  true  - a sheep present at given location.
     *  false - no sheep present at given location.
     */
    public boolean hasSheepAt(int x, int y)
    {
        java.util.List lTemp = getObjectsAt(x, y, Sheep.class);

        return !lTemp.isEmpty();
    }

    /**
     * This function checks if a given location has a grass-patch or not.
     * Input :
     *  x - x-index in cell units for given location.
     *  y - y-index in cell units for given location.
     *  
     *  Output : A boolean flag indicating if the presence/absence of a sheep.
     *  true  - a grass-patch present at given location.
     *  false - no grass-patch present at given location.
     */
    public boolean hasGrassAt(int x, int y)
    {
        java.util.List lTemp = getObjectsAt(x, y, Grass.class);

        return !lTemp.isEmpty();
    }
    
    /**
     * This function removes all the grass patches at a given location.
     * Input :
     *  x - x-index in cell units for given location.
     *  y - y-index in cell units for given location.
     */
    public void eatGrassAt(int x, int y)
    {
        java.util.List lTemp = getObjectsAt(x, y, Grass.class);

        if(!lTemp.isEmpty())
        {
            removeObject((Actor)lTemp.get(0));
        }
    }
    
    
    /**
     * This function removes a sheep at a given location.
     * Input :
     *  x - x-index in cell units for given location.
     *  y - y-index in cell units for given location.
     */
    public void eatSheepAt(int x, int y)
    {
        java.util.List lTemp = getObjectsAt(x, y, Sheep.class);

        if(!lTemp.isEmpty())
        {
            removeObject((Actor)lTemp.get(0));
        }
    }

    /**
     * This function checks if a given location has a solid object (sheep/brick).
     * Input :
     *  x - x-index in cell units for given location.
     *  y - y-index in cell units for given location.
     *  
     *  Output : A boolean flag indicating if the presence/absence of a sheep.
     *  true  - a solid object present at given location.
     *  false - no solid object present at given location.
     */
    public boolean hasSolidAt(int x, int y)
    {
        return hasBrickAt(x, y) || hasSheepAt(x, y);
    }
    

    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     * 
     * This function is auto-generated by the Greenfoot development environment when 
     * you do "save world" by right-clicking on the world-instance in the main window.
     */
    private void prepare()
    {
     
        Sheep sheep = new Sheep();
        addObject(sheep, 14, 16);
        sheep.setDirection(true, true, false, false);
       
        
        Grass grass = new Grass();
        addObject(grass, 20, 17);
        
        /**for (int i=1;i < 40 ;++i) {
            for (int j= 1; j < FLD_WID -1; ++j) {
                Grass grass= new Grass();
                addObject(grass, j,i);
            }
        }*/

        // Add bricks to the leftmost and rightmost columns of the field.
        /**for (int j=1; j < FLD_HGH; ++j) {
            Brick bTemp = new Brick();
            addObject(bTemp, 0, j);

            bTemp = new Brick();
            addObject(bTemp, FLD_WID-1,j);

        }
        
        // Add bricks to last row in the field.
        for (int j= 0; j < FLD_WID; ++j) {
            Brick bTemp = new Brick();
            addObject(bTemp, j,FLD_HGH-1);
        }*/
       
    }
    
 }


